apiVersion: triggers.tekton.dev/v1beta1
kind: EventListener
metadata:
  name: ping-frontend-pipeline-gitlab-webhook
spec:
  serviceAccountName: gitlab-eventlistener
  triggers:
    - name: run-pipeline-on-gitlab-push
      template:
        ref: run-ping-frontend-pipeline
      interceptors:
      - ref:
          name: "gitlab"
        params:
        - name: "secretRef"
          value:
            secretName: with-humans-devops-workshop-socrates-ping-frontend-tekton-hook-secret
            secretKey: token
        - name: "eventTypes"
          value: ["Push Hook"]
      bindings:
      - name: before
        value: $(body.before)
      - name: after
        value: $(body.after)
      - name: ref
        value: "$(body.ref)"
---
apiVersion: triggers.tekton.dev/v1beta1
kind: TriggerTemplate
metadata:
  name: run-ping-frontend-pipeline
spec:
  params:
    - name: before
      description: The commit before push
      default: "BEFORE_EMPTY"
    - name: after
      description: The commit after push
      default: "AFTER_EMPTY"
    - name: ref
      description: git ref, e.g. refs/head/main
      default: "REF_EMPTY"
  resourcetemplates:
  - apiVersion: tekton.dev/v1
    kind: PipelineRun
    metadata:
      generateName: ping-frontend-pipeline-run-
    spec:
      pipelineRef:
        name: ping-frontend-pipeline
      params:
        - name: before
          value: $(tt.params.before)
        - name: after
          value: $(tt.params.after)
        - name: ref
          value: $(tt.params.ref)
      workspaces:
        {{- if .Values.image.pullSecret }}
        - name: docker-registry-config
          secret:
            secretName: {{ .Values.image.pullSecret }}
        {{- end }}
        - name: infrastructure-key
          secret:
            secretName: with-humans-devops-workshop-socrates-infrastructure-deploy-key
        - name: ping-frontend-key
          secret:
            secretName: with-humans-devops-workshop-socrates-ping-frontend-deploy-key
        - name: shared-data
          subPath: repo/
          volumeClaimTemplate:
            spec:
              accessModes:
                - ReadWriteOnce
              resources:
                requests:
                  storage: 1Gi
